//______________________________________________________________________________

//            Hlavikov soubor knihovny Tcom052.dll verze 1.04

//                Copyright (c) 1998-2014 TEDIA spol. s r.o.
//______________________________________________________________________________

unit Tcom052;

interface
uses Windows, Classes, SysUtils, Wintypes;

//______________________________________________________________ NVRATOV A CHYBOV KDY

//   0      V podku
//   1      Chybn komunikan rychlost
//   2      (rezervovno)
//   3      Chyba pi vysln zprvy
//   4      Timeout - nepila dn odpov
//   5      Timeout - nepila sprvn odpov
//   6      Odpov peruena
//   7      Chyba parity odpovdi
//   8      Chybn hlavika odpovdi
//   9      Chyba CRC odpovdi
//  10      Nelze vytvoit datovou strukturu knihovny
//  11      Neplatn handle zazen
//  12      Neplatn slo zazen
//  13      Nelze otevt zazen
//  14      Zazen ji inicializovno
//  15      Chyba knihovny (voln API)
//  16      Chyba knihovny (voln API)
//  17      Chyba knihovny (voln API)
//  18      Chyba knihovny (voln API)
//  19      Chyba knihovny (voln API)
//  20      Chyba knihovny (voln API)

//______________________________________________________________ DATOV TYPY

type
  TBuff  = array[0..1023] of DWord; // pole DWord (1024 prvku)
  PTBuff = ^TBuff;                  // ukazatel na pole DWord


//______________________________________________________________ EXPORTOVAN FCE

// Vechny funkce vrac hodnotu 0 (DWord) v ppad spnho proveden.
// Nenulov hodnota signalizuje chybu, pro jej identifikaci lze pout
// funkci TCOM052_Error.




//............................................................. TCOM052_Version

// Vrac verzi knihovny DLL (nutno vydlit 100, nap. vrcen hodnota 100
// znamen verzi 1.00).
// Parametry funkce:
//  Ver - ukazatel na DWord

function TCOM052_Version(Ver:PDWord):DWord; stdcall;




//............................................................. TCOM052_Init

// Inicializuje knihovnu a otevre zadany COM.
// Nastav default komunikan parametry (9600Bd, timeout 10ms, 2 opakovn
// pi chyb). Vrac handle otevenho zazen.
// Parametry funkce:
//  PHNDL - ukazatel na DWord
//  COM - DWord s slem COM portu

function TCOM052_Init(PHNDL:PDWord; COM:DWord):DWord; stdcall;




//............................................................. TCOM052_SetConfig

// Nastav komunikan rychlost, timeout a opakovn pro komunikaci
// s moduly MicroUnit. Povolen rychlosti odpovdaj modulm MicroUnit,
// tj. 600Bd, 1200Bd, 2400Bd, 4800Bd, 9600Bd, 19200Bd, 38400Bd, 57600Bd
// a 115200Bd. Timeout, tj. max. doba ekn na zahjen odpovdi modulu,
// je nastaviteln od 1 do 65535ms. Opakovn uruje poet zopakovanch voln
// na modul MicroUnit v ppad chybn komunikace, tzn. nap. pro Opakovani=2
// je na modul MicroUnit volno v ppad chyby komunikace celkem 3x.
// Pokud vyhov default hodnoty konfigurace (viz. TCOM052_Init), nen nutno
// tuto funkci volat.
// Parametry funkce:
//  HNDL - DWord s pidlenm handle zazen
//  Baud,Timeout,Opakovani - DWord s nastavenm komunikanch parametr

function TCOM052_SetConfig(HNDL:DWord;Baud,Timeout,Opakovani:DWord):DWord; stdcall;




//............................................................. TCOM052_GetConfig

// Vrac nastavenou komunikan rychlost, timeout a opakovn pro komunikaci
// s moduly MicroUnit.
// Parametry funkce:
//  HNDL - DWord s pidlenm handle zazen
//  Baud,Timeout,Opakovani - ukazatel na DWord s nastavenmi komunikanmi parametry

function TCOM052_GetConfig(HNDL:DWord; Baud,Timeout,Opakovani:PDWord):DWord; stdcall;




//............................................................. TCOM052_Send

// Vyle dotaz (BuffT) na modul MicroUnit, vrt odpov modulu (BuffR),
// Status registr modulu (StatusR) a Status pjmu (StatusP).
// BuffT a BuffR jsou pole obsahujc vyslanou resp. pijatou zprvu.
// Obsah BuffT odpovd vyslan zprv protokolu AIBus-2, bez CRC. Pesn
// vznam je uveden v popisu protokolu.
//  BuffT[0] - adresa volanho modulu MicroUnit (0-255)
//  BuffT[1] - poadovan funkce AIBus-2 (0,1,2,3,100,101,102,103,200)
//  BuffT[2] - poadovan periferie modulu MicroUnit (0-255)
//  BuffT[3] - pm povel (0)
//  BuffT[4] - D1 datov byte dotazu (0-255)
//  BuffT[5] - D2 datov byte dotazu (0-255)
//  BuffT[6] - D3 datov byte dotazu (0-255)
//  BuffT[7] - D4 datov byte dotazu (0-255)
// Pole RBuff obsahuje pouze pijat datov byty odpovdi.
//  BuffR[0] - D1 datov byte odpovdi (0-255)
//  BuffR[1] - D2 datov byte odpovdi (0-255)
//  BuffR[2] - D3 datov byte odpovdi (0-255)
//  BuffR[3] - D4 datov byte odpovdi (0-255)
// StatusR obsahuje pijat Status registr modulu.
// Ve StatusP je uloen kd spnosti komunikace s modulem MicroUnit.
// Slovn popis kdu lze zskat pomoc funkce TCOM052_Error.
// Parametry funkce:
//  HNDL - DWord s pidlenm handle zazen
//  BuffT,BuffR - ukazatele na pole
//  StatusR,StatusP - ukazatele na DWord

function TCOM052_Send(HNDL:DWord;BuffT,BuffR:PTBuff;StatusR,StatusP:PDWord):DWord; stdcall;




//............................................................. TCOM052_Done

// Uzavre otevren zarzen a uvoln knihovnu z pameti.
// Parametry funkce:
//  PHNDL - ukazatel na DWord s pridelenm handle zarzen

function TCOM052_Done(PHNDL:PDWord):DWord; stdcall;




//............................................................. TCOM052_Error

// Prevede nvratov kd na text.
// Parametry funkce:
//  ErrCode - DWord
//  ErrText - ukazatel na pole ErrText

function TCOM052_Error(ErrCode:DWord; ErrText:PTBuff):DWord; stdcall;


//________________________________________________________________ IMPLEMENTACE

implementation

//______________________________________________________________________________

function TCOM052_Version;                             external 'Tcom052.dll';
function TCOM052_Init;                                external 'Tcom052.dll';
function TCOM052_SetConfig;                           external 'Tcom052.dll';
function TCOM052_GetConfig;                           external 'Tcom052.dll';
function TCOM052_Send;                                external 'Tcom052.dll';
function TCOM052_Done;                                external 'Tcom052.dll';
function TCOM052_Error;                               external 'Tcom052.dll';

//______________________________________________________________________________

begin
end.


